var o_ControlData = null;
var m_backBtnImage	= new Image();
var m_backBtnDisabledImage	= new Image();
var m_cancelBtnImage	= new Image();
var m_cancelBtnDisabledImage	= new Image();
var m_finishBtnImage	= new Image();
var m_finishBtnDisabledImage	= new Image();
var m_nextBtnImage	= new Image();
var m_nextBtnDisabledImage	= new Image();

function enableDisableButton(sBN, bState)
{
	var i;
	var xi;
	i = getButtonImage( sBN );
	if (null == i)
	{
		return;
	}
	if (bState)
		xi = getButtonEnabledImage( sBN );
	else 
		xi = getButtonDisabledImage( sBN );
	if (null != xi)
	{
		i.src = xi.src;
	}
}

function getButtonDisabledImage(sBN)
{
	var	i;
	if ("PB_Back" == sBN) i = m_backBtnDisabledImage;
	else if ("PB_Cancel" == sBN) i = m_cancelBtnDisabledImage;
	else if ("PB_Finish" == sBN) i = m_finishBtnDisabledImage;
	else if ("PB_Next" == sBN) i = m_nextBtnDisabledImage;
	else i = null;
	return i;
}

function getButtonEnabledImage(sBN)
{
	var	i;
	if ("PB_Back" == sBN) i = m_backBtnImage;
	else if ("PB_Cancel" == sBN) i = m_cancelBtnImage;
	else if ("PB_Finish" == sBN) i = m_finishBtnImage;
	else if ("PB_Next" == sBN) i = m_nextBtnImage;
	else i = null;
	return i;
}

function getButtonImage(sBN)
{
	var	e;
	if ("PB_Back" == sBN) e = document.PB_Back;
	else if ("PB_Cancel" == sBN) e = document.PB_Cancel;
	else if ("PB_Finish" == sBN) e = document.PB_Finish;
	else if ("PB_Next" == sBN) e = document.PB_Next;
	else e = null;
	return e;
}

function getButtonState(sBN)
{
	var	bState = false;
	if (null != o_ControlData)
	{
		if ("PB_Back" == sBN) bState = o_ControlData.disableBack;
		else if ("PB_Cancel" == sBN) bState = o_ControlData.disableCancel;
		else if ("PB_Finish" == sBN) bState = o_ControlData.disableFinish;
 		else if ("PB_Next" == sBN) bState = o_ControlData.disableNext;
	}
	return (!bState);
}

function handleBackPB()
{
	if ((null != o_ControlData) && (!o_ControlData.disableBack))
	{
		handleControlPB( "PB_Back" );
	}
	return( false );
}

function handleCancelPB()
{
	var	bReply;
	bReply = ((null == o_ControlData) || o_ControlData.disableCancel);
	if (!bReply)
	{
		handleControlPB( "PB_Cancel" );
	}
	return( bReply );
}

function handleDefaultPB()
{
	var	bReply;
	bReply = ((null == o_ControlData) || o_ControlData.disableNext);
	if (!bReply)
	{
		handleControlPB( "PB_Next" );
	}
	return( bReply );
}

function handleControlPB(sPB)
{
	with (getDataForm())
	{
		if ("PB_Start" == sPB)
		{
			sPB = "PB_Finish";
		}
		if (getButtonState( sPB ))
		{
			Hidden_PB_Other.value = "";
			Hidden_PB_Control.value = sPB;
			if (parent.window.DataFrame.validateForm())
			{
				submitMain();
			}
		}
	}
}

function modifyControl(oData)
{
	if (null == oData)
	{
		return;
	}
	if (null != o_ControlData)
	{
		if (!(isDefined( oData.disableBack ))) 
			oData.disableBack = o_ControlData.disableBack;
		if (!(isDefined( oData.disableCancel ))) 
			oData.disableCancel = o_ControlData.disableCancel;
		if (!(isDefined( oData.disableFinish ))) 
			oData.disableFinish = o_ControlData.disableFinish;
		if (!(isDefined( oData.disableNext ))) 
			oData.disableNext = o_ControlData.disableNext;
	}
	updateControl( oData );
}

function controlDataEqual(oData1, oData2)
{
	if ((null == oData1) || (null == oData2))
	{
		return( oData1 == oData2 );
	}
	if ((oData1.disableBack == oData2.disableBack) && (oData1.disableCancel == oData2.disableCancel) 
		&& (oData1.disableFinish == oData2.disableFinish) 
 		&& (oData1.disableNext == oData2.disableNext))
	{
		return( true );
	}
	return( false );
}

function normalizeControlData(oData)
{
	var	r;
	if (null == oData)
		r = new Object();
	else r = oData;
	if (!(isDefined( r.disableBack ))) r.disableBack = false;
	if (!(isDefined( r.disableCancel ))) r.disableCancel = false;
	if (!(isDefined( r.disableFinish ))) r.disableFinish = false;
	if (!(isDefined( r.disableNext ))) r.disableNext = false;
	return( r );
}

function showDisabledButtons()
{
	var	oData;
	oData = new Object();
	oData.disableBack = true;
	oData.disableCancel = true;
	oData.disableFinish = true;
	oData.disableNext = true;
	updateControl( oData );
}

function showHideButton(pbID, bState)
{
	var	pbE;
	pbE = document.getElementById( pbID );
	if (null != pbE)
	{
		if (bState)
			pbE.style.visibility = "visible";
		else 
			pbE.style.visibility = "hidden";
	}
}

function updateControl(oData)
{
	with (getControlForm())
	{
		var	i;
		var	u;
		oData = normalizeControlData( oData );
		if (controlDataEqual( oData, o_ControlData ))
		{
			return;
		}
		o_ControlData = oData;
		enableDisableButton( "PB_Back", !oData.disableBack );
		enableDisableButton( "PB_Cancel", !oData.disableCancel );
		enableDisableButton( "PB_Finish", !oData.disableFinish );
		enableDisableButton( "PB_Next", !oData.disableNext );
	}
}
