function initializePanel_Common()
{
	window.status = "";
}

function hasString(sValue)
{
	return((null != sValue) && (0 < sValue.length) );
}

function isAnchor(e)
{
	var	bReply;
	bReply = (null != e);
	if (bReply)
	{
		var	sT;
		sT = e.tagName;
		bReply = hasString( sT );
		if (bReply)
		{
			bReply = (("a" == sT) || ("A" == sT));
		}
	}
	return( bReply );
}

function isDefined(o)
{
	var	sType;
	sType = typeof o;
	return(("undefined" != sType) && ("unknown" != sType));
}

function isPB(e)
{
	var	bReply;
	bReply = (null != e);
	if (bReply)
	{
		var	sT;
		sT = e.type;
		bReply = hasString( sT );
		if (bReply)
		{
			bReply = (("button" == sT) || ("image" == sT) || ("submit" == sT));
		}
	}
	return( bReply );
}

function canEnter(e)
{
	return( isAnchor( e ) || isPB( e ) );
}

function canType(e)
{
	var	sT;
	if ((null == e) || e.disabled || e.readOnly)
	{
		return( false );
	}
	sT = e.type;
	return(("file" == e.type) || ("text" == e.type) || ("textarea" == e.type) || ("password" == e.type));
}

function getNamedElement(sName, fGetForm)
{
	if ((!(isDefined( fGetForm ))) || (null == fGetForm))
	{
		fGetForm = getDataForm;
	}
	with (fGetForm())
	{
		var	eElement;
		var	i;
		for (i = 0; i < elements.length; i += 1)
		{
			eElement = elements[i];
			if (eElement.name == sName)
			{
				return( eElement );
			}
		}
	}
	return( null );
}

function isControlPB(sPB)
{
	return(hasString( sPB ) && (("PB_Back" == sPB) || ("PB_Cancel" == sPB) || ("PB_Close" == sPB) || ("PB_Finish" == sPB) 
									|| ("PB_Next" == sPB) || ("PB_Ok" == sPB) || ("PB_Start" == sPB)) );
}

function validateForm()
{
	return( validateForm_PerPanel() );
}

function hideDivs(div01, div02, div03)
{
	if (div01) document.all[div01].style.visibility = "hidden";
	if (div02) document.all[div02].style.visibility = "hidden";
	if (div03) document.all[div03].style.visibility = "hidden";
}

function showDivs(div01, div02,	div03)
{
	if (div01) document.all[div01].style.visibility = "visible";
	if (div02) document.all[div02].style.visibility = "visible";
	if (div03) document.all[div03].style.visibility = "visible";
}

function onKeyDown_Accelerator()
{
	with (getDataForm())
	{
		var	bReply;
		var	eSrc;
		var	iKey;
		var	oEvent;
		oEvent = window.event;
		eSrc = oEvent.srcElement;
		iKey = oEvent.keyCode;
		switch (iKey)
		{
			case 8:
				bReply = canType( eSrc );
				if (!bReply)
				{
					bReply = parent.window.ControlFrame.handleBackPB();
				}
				break;
			case 13:
				bReply = canEnter( eSrc );
				if (!bReply)
				{
					bReply = parent.window.ControlFrame.handleDefaultPB();
				}
				break;
			case 27:
				bReply = parent.window.ControlFrame.handleCancelPB();
				break;
			default:
				bReply = true;
			break;
		}
		return( bReply );
	}
}

function getCancelForm() {return( getForm_Impl("CancelForm"));}
function getBackForm() {return( getForm_Impl("BackForm"));}
function getDataForm() 	 {return( getForm_Impl( "DataForm" ));}
function getControlForm() {return ( getForm_Impl( "ControlForm" ));}

function getForm_Impl(sForm)
{
	var	oReply;
	oReply = null;
	if (hasString( sForm ))
	{
		if ("DataForm" == sForm)
		{
			if (isDefined( document.DataForm )) oReply = document.DataForm;
			else if (isDefined( window.DataFrame )) oReply = window.DataFrame.document.DataForm;
			else if (isDefined( parent.window.DataFrame )) oReply = parent.window.DataFrame.document.DataForm;
		}
		else if ("BackForm" == sForm)
		{
			if (isDefined( document.BackForm )) oReply = document.BackForm;
			else if (isDefined( window.DataFrame )) oReply = window.DataFrame.document.BackForm;
			else if (isDefined( parent.window.DataFrame )) oReply = parent.window.DataFrame.document.BackForm;
		}
		else if ("CancelForm" == sForm)
		{
			if (isDefined( document.CancelForm )) oReply = document.CancelForm;
			else if (isDefined( window.DataFrame )) oReply = window.DataFrame.document.CancelForm;
			else if (isDefined( parent.window.DataFrame )) oReply = parent.window.DataFrame.document.CancelForm;
		}
		else if ("ControlForm" == sForm)
		{
			if (isDefined( document.ControlForm )) oReply = document.ControlForm;
			else if (isDefined( window.ControlFrame )) oReply = window.ControlFrame.document.ControlForm;
			else if (isDefined( parent.window.ControlFrame )) oReply = parent.window.ControlFrame.document.ControlForm;
		}
	}
	return( oReply );
}

function getPBClicked()
{
	with (getDataForm())
	{
		return( Hidden_PB_Control.value );
	}
}

function handleOtherPB(sPB)
{
	with (getDataForm())
	{
		Hidden_PB_Other.value = sPB;
		Hidden_PB_Control.value = "";
		if (validateForm())
		{
			submitMain();
		}
	}
}

function okToCancel()
{
	return true;
}


function submitMain()
{
	with (getDataForm())
	{
		if (isDefined( window.ControlFrame )) 
			window.ControlFrame.showDisabledButtons();
		else if (isDefined( parent.window.ControlFrame )) 
			parent.window.ControlFrame.showDisabledButtons();
		submit();
	}
}

